Unit ef04r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, IA20R_p, AVZ2R_p;

procedure ef04r(M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; var DELTA :Array of Real; P :Real;
                var NG :Integer; var V1 :Array of Real;
                var V2 :Array of Real; var MU :Array of Integer;
                var H :Array of Real; var UP :Array of Real;
                var U :Array of Real; var B :Array of Real);

implementation

procedure ef04r(M :Integer; var N :Integer; var A :Array of Real;
                var F :Array of Real; var DELTA :Array of Real; P :Real;
                var NG :Integer; var V1 :Array of Real;
                var V2 :Array of Real; var MU :Array of Integer;
                var H :Array of Real; var UP :Array of Real;
                var U :Array of Real; var B :Array of Real);
var
I,I1,I2,I3,IM,IP,IS_,IXP,J,K,K1,K2,K3,K4,K5,KN,L,NP :Integer;
R,S,W,W1 :Real;
const
E :Real = 1.0E-5;
ISP :Integer = 20;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,_160,_170,
_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,_300,_310,_320,
_330,_340,_350,_360;
begin
K := M + M;
K1 := K + M;
K2 := K1 + N;
K3 := K2 + N;
K4 := K3 + N;
K5 := K4 + N + 1;
H[N-1] := 0.0;
W := 0.0;
for J:=1 to N do
 begin
  I1 := K3 + J;
  I2 := K4 + J;
  I3 := K5 + J;
  W1 := W + 0.5*H[J-1];
  B[I1-1] := 1.0/W1;
  B[I2-1] := 0.0;
  B[I3-1] := W1;
  W := 0.5*H[J-1];
_10:
 end;
B[K5-1] := 0.0;
for I:=1 to M do
 begin
  B[I-1] := 0.0;
  for J:=1 to N do
   begin
    I3 := K5 + J;
    A[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*B[I3-1];
    B[I-1] := B[I-1] + A[(I-1)+(J-1)*M]*A[(I-1)+(J-1)*M];
_20:
   end;
_30:
 end;
_40:
for J:=1 to N do
 begin
  U[J-1] := UP[J-1];
_50:
 end;
IS_ := 0;
_60:
IP := 0;
_70:
L := 1;
_80:
NP := 1;
for I:=1 to M do
 begin
  I1 := M + I;
  B[I1-1] := 0.0;
  for J:=1 to N do
   begin
    B[I1-1] := B[I1-1] + A[(I-1)+(J-1)*M]*U[J-1];
_90:
   end;
_100:
 end;
for I:=1 to M do
 begin
  I1 := K + I;
  I2 := M + I;
  B[I1-1] := Abs(B[I2-1] - F[I-1]) - DELTA[I-1];
  if ( B[I1-1] - 1.E-4*DELTA[I-1] ) < 0
   then goto _130
   else if ( B[I1-1] - 1.E-4*DELTA[I-1] ) > 0
         then goto _110
         else goto _130;
_110:
  W := Sqrt(B[I-1]);
  B[I1-1] := B[I1-1]/W;
  W1 := 0.1*DELTA[I-1]/W;
  if ( B[I1-1] - W1 ) < 0
   then goto _140
   else if ( B[I1-1] - W1 ) > 0
         then goto _120
         else goto _140;
_120:
  NP := 2;
  goto _140;
_130:
  B[I1-1] := 0.0;
_140:
 end;
case NP of
 1: goto _150;
 2: goto _190;
end;
_150:
if ( NG ) < 0
 then goto _160
 else if ( NG ) > 0
       then goto _160
       else goto _360;
_160:
case L of
 1: goto _170;
 2: goto _360;
end;
_170:
L := 2;
for J:=1 to N do
 begin
  I1 := K2 + J;
  B[I1-1] := U[J-1];
_180:
 end;
IA20R(N,B[K2+0],NG,V1,V2,MU,H,B[K3+0],B[K4+0],E,ISP,0,U,
                W,KN,B[K5+0]);
goto _80;
_190:
if ( IS_ - N ) < 0
 then goto _220
 else if ( IS_ - N ) > 0
       then goto _200
       else goto _220;
_200:
for I:=1 to M do
 begin
  DELTA[I-1] := DELTA[I-1] + P*DELTA[I-1];
_210:
 end;
goto _40;
_220:
R := AVZ2R(B[K+0],M,1,IM);
IM := IM;
_230:
I1 := M + IM;
W := B[I1-1] - F[IM-1];
S := R*Sign(1.0,W)/Sqrt(B[IM-1]);
for J:=1 to N do
 begin
  U[J-1] := U[J-1] - S*A[(IM-1)+(J-1)*M];
_240:
 end;
IP := IP + 1;
case IP of
 1: goto _250;
 2: goto _270;
 3: goto _330;
end;
_250:
IXP := IM;
for J:=1 to N do
 begin
  I1 := K1 + J;
  B[I1-1] := U[J-1];
_260:
 end;
goto _70;
_270:
R := 0.0;
for J:=1 to N do
 begin
  R := R + A[(IXP-1)+(J-1)*M]*U[J-1];
_280:
 end;
I1 := M + IXP;
B[I1-1] := R;
W := Abs(R-F[IXP-1]) - DELTA[IXP-1];
if ( W - 1.E-4*DELTA[IXP-1] ) < 0
 then goto _290
 else if ( W - 1.E-4*DELTA[IXP-1] ) > 0
       then goto _300
       else goto _290;
_290:
R := 0.0;
goto _310;
_300:
R := W/Sqrt(B[IXP-1]);
_310:
IM := IXP;
for J:=1 to N do
 begin
  I2 := K2 + J;
  B[I2-1] := U[J-1];
_320:
 end;
goto _230;
_330:
R := 0.0;
W := 0.0;
for J:=1 to N do
 begin
  I1 := K1 + J;
  I2 := K2 + J;
  S := B[I1-1] - B[I2-1];
  R := R + S*S;
  W := W + S*(B[I1-1] - U[J-1]);
_340:
 end;
W := R/W;
for J:=1 to N do
 begin
  I1 := K1 + J;
  U[J-1] := B[I1-1] + W*(U[J-1] - B[I1-1]);
_350:
 end;
IS_ := IS_ + 1;
goto _60;
_360:
end;

end.
