Unit ia20r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, IA01R_p, IA201_p, IA202_p;

procedure ia20r(var N :Integer; var F :Array of Real; NG :Integer;
                var V1 :Array of Real; var V2 :Array of Real;
                var MU :Array of Integer; var H :Array of Real;
                var P :Array of Real; var R :Array of Real; E :Real;
                ISP :Integer; LU :Integer; var U :Array of Real;
                var FU :Real; var KN :Integer; var B :Array of Real);

implementation

procedure ia20r(var N :Integer; var F :Array of Real; NG :Integer;
                var V1 :Array of Real; var V2 :Array of Real;
                var MU :Array of Integer; var H :Array of Real;
                var P :Array of Real; var R :Array of Real; E :Real;
                ISP :Integer; LU :Integer; var U :Array of Real;
                var FU :Real; var KN :Integer; var B :Array of Real);
var
N1,NX,NGX,IS_,K,K1,K2,K3,K4,J,J0,J1,J2,J3,J4 :Integer;
S,W,W1,WF,FS,BETA,AS_,E2,E3,E4,Z :Real;
GRG,GRN,Z1 :Extended;
const
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20,
_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,_37,
_38,_39,_40,_41,_42,_43,_44,_45,_46,_47;
begin
S := U[0];
N1 := N-1;
for J:=1 to N1 do
 begin
_1:
  U[J-1] := (U[J+0]-U[J-1])/H[J-1];
 end;
U[N-1] := S;
if ( LU ) < 0
 then goto _3
 else if ( LU ) > 0
       then goto _3
       else goto _2;
_2:
N1 := N;
V1[N-1] := -SYS059;
V2[N-1] := SYS059;
goto _5;
_3:
for J:=1 to N do
 begin
_4:
  F[J-1] := F[J-1]-S;
 end;
_5:
MU[N-2] := 0;
MU[N-1] := 0;
R[N-1] := 0.0;
R[N+0] := 0.0;
H[N-1] := 0.0;
IS_ := 0;
KN := 0;
NX := 1;
NGX := NG+1;
K := N+N;
K1 := K+N;
K2 := K1+N;
K3 := K2+N;
K4 := K3+N;
_6:
case NGX of
 1: goto _16;
 2: goto _7;
 3: goto _12;
 4: goto _12;
end;
_7:
for J:=1 to N1 do
 begin
  if ( U[J-1]-V1[J-1] ) < 0
   then goto _8
   else if ( U[J-1]-V1[J-1] ) > 0
         then goto _9
         else goto _11;
_8:
  U[J-1] := V1[J-1];
  goto _11;
_9:
  if ( U[J-1]-V2[J-1] ) < 0
   then goto _11
   else if ( U[J-1]-V2[J-1] ) > 0
         then goto _10
         else goto _11;
_10:
  U[J-1] := V2[J-1];
_11:
 end;
goto _16;
_12:
case NX of
 1: goto _13;
 2: goto _15;
end;
_13:
for J:=1 to N1 do
 begin
  J4 := K4+J;
  B[J4-1] := U[J-1];
_14:
 end;
_15:
IA01R(B[K4+0],U,H,MU,N1);
if ( NGX-4 ) < 0
 then goto _16
 else if ( NGX-4 ) > 0
       then goto _16
       else goto _7;
_16:
IA201(LU,N,H,U,B[N+0]);
W1 := 0.0;
FU := 0.0;
for J:=1 to N do
 begin
  J1 := N+J;
  W := B[J1-1]-F[J-1];
  B[J1-1] := P[J-1]*(W1+H[J-1])/2.0*W;
  FU := FU+W*B[J1-1];
_17:
  W1 := H[J-1];
 end;
case NX of
 1: goto _18;
 2: goto _32;
end;
_18:
NX := 2;
IA202(LU,N,H,R,B);
FS := FU;
for J:=1 to N1 do
 begin
_19:
  B[J-1] := U[J-1];
 end;
if ( IS_ ) < 0
 then goto _22
 else if ( IS_ ) > 0
       then goto _22
       else goto _20;
_20:
for J:=1 to N1 do
 begin
  J1 := K1+J;
  J3 := K3+J;
_21:
  B[J3-1] := B[J1-1];
 end;
goto _25;
_22:
W := 0.0;
for J:=1 to N1 do
 begin
  J0 := K+J;
  J1 := K1+J;
  J2 := K2+J;
_23:
  W := W+B[J0-1]*(B[J2-1]-B[J1-1]);
 end;
BETA := W/GRN;
for J:=1 to N1 do
 begin
  J1 := K1+J;
  J3 := K3+J;
_24:
  B[J3-1] := B[J1-1]-BETA*B[J3-1];
 end;
_25:
GRG := 0.0;
GRN := 0.0;
for J:=1 to N1 do
 begin
  J0 := K+J;
  J1 := K1+J;
  J3 := K3+J;
  Z := B[J0-1];
  GRG := GRG+B[J3-1]*Z;
  GRN := GRN+B[J1-1]*Z;
_26:
 end;
W := Sqrt(GRN);
if ( Abs(W)-E ) < 0
 then goto _42
 else if ( Abs(W)-E ) > 0
       then goto _27
       else goto _42;
_27:
if ( GRG ) < 0
 then goto _20
 else if ( GRG ) > 0
       then goto _28
       else goto _28;
_28:
IA201(LU,N,H,B[K3+0],B[N+0]);
Z := 0.0;
W1 := 0.0;
for J:=1 to N do
 begin
  J0 := N+J;
  Z1 := P[J-1]*(W1+H[J-1])*B[J0-1];
  W1 := H[J-1];
_29:
  Z := Z+Z1*B[J0-1];
 end;
AS_ := GRN/Z;
_30:
for J:=1 to N1 do
 begin
  J3 := K3+J;
  J4 := K4+J;
  B[J4-1] := B[J-1]-AS_*B[J3-1];
_31:
  U[J-1] := B[J4-1];
 end;
goto _6;
_32:
E2 := E*E/Abs(Z);
E3 := E*E*E2;
WF := FS-FU;
if ( Abs(WF)-E3 ) < 0
 then goto _33
 else if ( Abs(WF)-E3 ) > 0
       then goto _34
       else goto _33;
_33:
KN := 2;
goto _43;
_34:
if ( WF ) < 0
 then goto _39
 else if ( WF ) > 0
       then goto _35
       else goto _35;
_35:
IS_ := IS_+1;
if ( ISP-IS_ ) < 0
 then goto _37
 else if ( ISP-IS_ ) > 0
       then goto _37
       else goto _36;
_36:
KN := 0;
goto _43;
_37:
for J:=1 to N1 do
 begin
  J1 := K1+J;
  J2 := K2+J;
_38:
  B[J2-1] := B[J1-1];
 end;
goto _18;
_39:
AS_ := 0.5*AS_;
if ( AS_-E2 ) < 0
 then goto _40
 else if ( AS_-E2 ) > 0
       then goto _30
       else goto _40;
_40:
E4 := E*E2;
for J:=1 to N1 do
 begin
  if ( Abs(U[J-1]-B[J-1])-E4 ) < 0
   then goto _41
   else if ( Abs(U[J-1]-B[J-1])-E4 ) > 0
         then goto _30
         else goto _41;
_41:
 end;
KN := 3;
goto _43;
_42:
KN := 1;
_43:
N1 := N-1;
W := U[N-1];
for J:=1 to N1 do
 begin
  S := W;
  W := S+H[J-1]*U[J-1];
_44:
  U[J-1] := S;
 end;
U[N-1] := W;
if ( LU ) < 0
 then goto _45
 else if ( LU ) > 0
       then goto _45
       else goto _47;
_45:
for J:=1 to N do
 begin
_46:
  F[J-1] := F[J-1]+U[0];
 end;
_47:
end;

end.
